void printf_xy(int x, int y, const char *format, ...)	{ 
	int *a=NULL;
	char      vbuf[1024];
	va_list   arg_ptr;
	va_start(arg_ptr, format);
	_vsnprintf(vbuf, sizeof(vbuf), format, arg_ptr);
	DessTexte(x,y,vbuf);
}

int texteX=0, texteY=0;
int WordWrap=1, gblIndex=-1, gblX=0, gblY=0;

#undef printf

#define LARG_CAR 8
#define HAUT_CAR 12
BOOL printfMode=0;
#define printfLent()	(printfMode=0)
#define printfRapide()	(printfMode=1)
#define MoveTo(x,y)		(texteX=(x)*LARG_CAR, texteY=(y)*HAUT_CAR)

#ifndef MODE_WIN
void printfOk()		{
	COORD positions;
	positions.X=texteX/LARG_CAR;
	positions.Y=texteY/HAUT_CAR;
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),positions);
	AfficheEcran();
}

void MajPartie(int y0, int y1)		{
	COORD positions;
	positions.X=texteX/LARG_CAR;
	positions.Y=texteY/HAUT_CAR;
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),positions);
	BitBlt(hdcConsole,offsetX,offsetY+y0,LARG,y1-y0,hdcImage,0,y0,SRCCOPY);
}
#else
#define printfOk()
#endif

int printf(const char *format, ...)	{ 
	int *a=NULL, i,j, defile=0, yAvant=texteY,x,ii,passeLigne=0;
	char      vbuf[1024];
	va_list   arg_ptr;

	va_start(arg_ptr, format);
	j=_vsnprintf(vbuf, sizeof(vbuf), format, arg_ptr);
	ModeTexte(TRANSPARENT);

	ChangeFonte("Courier New",16);

	for (i=0;i<j;i++)	{
		if (texteY>=HAUT-HAUT_CAR)		{
			memmove(Bits+LARG_BUF*3*HAUT_CAR,Bits,LARG_BUF*HAUT_BUF*3-LARG_BUF*3*HAUT_CAR);
			memset(Bits,0,LARG_BUF*3*HAUT_CAR);
			defile=1;
			texteY-=HAUT_CAR;
		}

		if (WordWrap)		{
/*			if (vbuf[i]==' ' || vbuf[i]=='\'' || vbuf[i]==',' || vbuf[i]=='\"' || vbuf[i]=='.' || vbuf[i]==':' || vbuf[i]==';' || vbuf[i]=='-' || vbuf[i]=='<' || vbuf[i]=='>' || vbuf[i]=='\\' || vbuf[i]=='(' || vbuf[i]==')' || vbuf[i]=='[' || vbuf[i]==']' || vbuf[i]=='+' || vbuf[i]=='*' || vbuf[i]=='&' || vbuf[i]=='|' || vbuf[i]=='/')		{
				x=texteX;
				ii=i+1;
				while(!(vbuf[ii]==' ' || vbuf[ii]=='\'' || vbuf[ii]==',' || vbuf[ii]=='\"' || vbuf[ii]=='.' || vbuf[ii]==':' || vbuf[ii]==';' || vbuf[ii]=='-' || vbuf[ii]=='<' || vbuf[ii]=='>' || vbuf[ii]=='\\' || vbuf[ii]=='(' || vbuf[ii]==')' || vbuf[ii]=='[' || vbuf[ii]==']' || vbuf[ii]=='+' || vbuf[ii]=='*' || vbuf[ii]=='&' || vbuf[ii]=='|' || vbuf[ii]=='/') && vbuf[ii])
					x+=LARG_CAR, ii++;
*/
			if (vbuf[i]==' ')		{
				x=texteX;
				ii=i+1;
				while(!(vbuf[ii]==' ') && vbuf[ii])
					x+=LARG_CAR, ii++;
				if (x>=LARG)		{
					passeLigne=1;
				}
			}
		}

		if (vbuf[i]=='\n')		{
			if (gblIndex==i)
				gblX=texteX, gblY=texteY;
			texteX=0;
			texteY+=HAUT_CAR;
			continue;
		}

		if (gblIndex==i)
			gblX=texteX, gblY=texteY;

		ColoreCadre(texteX,texteY,LARG_CAR,HAUT_CAR,0);
		TextOut(hdcImage,texteX,texteY-2,vbuf+i,1);

		texteX+=LARG_CAR;
		if (texteX>=LARG || passeLigne)		{
			passeLigne=0;
			texteX=0;
			texteY+=HAUT_CAR;
			if (vbuf[i+1]==' ' && WordWrap)
				i++;
		}
	}
	if (gblIndex==i)
		gblX=texteX, gblY=texteY;
#ifndef MODE_WIN
	if (!printfMode)		{
		if (defile)
			printfOk();
		else
			MajPartie(yAvant,texteY+HAUT_CAR);
	}
#endif
	gblIndex=-1;
	return 0;
}

#ifndef MODE_WIN
void AffCurseur()		{
//	InverseCadre(texteX,texteY,LARG_CAR-1,HAUT_CAR-2);
	InverseCadre(texteX,texteY+HAUT_CAR-4,LARG_CAR-1,2);
//	InverseCadre(texteX,texteY,2,HAUT_CAR-2);
}
#endif

#ifndef MODE_WIN
int Getch()		{
	int i,j=-1,c=FALSE;
	printfOk();
	while(!kbhit())		{
		i=GetTickCount();
		if (j<0 || j/500!=i/500)	{
			AffCurseur();
			c=!c;
		}
		AfficheEcran();
		j=i;
	}
	FlushConsoleInputBuffer(GetStdHandle(STD_INPUT_HANDLE));
	if (c)
		AffCurseur();
	for (i=0;i<256;i++)
		if (toucheAppuyee(i))
			return i;
	return 0;
}
#else
#define Getch getch
int keybhit()		{
	int i;
	for (i=0;i<256;i++)
		if (toucheAppuyee((UCHAR)i))
			return i;
	return 0;
}

/*int getch()		{
	int i;
	if (DoubleBuffer)
		AfficheEcran();
	do		{
		while(!(i=kbhit()))
			Sleep(1);
	}  while(!(i>=8 && i<=255 && !(i>=0x10 && i<0x20)));
	return i;
}

int getkey()		{
	int i;
	if (DoubleBuffer)
		AfficheEcran();
	while(!(i=kbhit()))
		Sleep(1);
	return i;
}*/
#define MAX_TOUCHES 256
int nTouches=0;
unsigned char chars[MAX_TOUCHES+1];

void pushkey(int k)	{
	if (nTouches<MAX_TOUCHES-1)
		nTouches++;
	chars[nTouches]=k;
}

int getkey()	{
	if (nTouches<=0)
		return 0;
	memmove(chars,chars+1,MAX_TOUCHES-1);
	nTouches--;
	return chars[0];
}

int kbhit()	{
	if (nTouches<=0)
		return 0;
	return chars[1];
}

int getch()		{
	int i;
	while(!(i=getkey()));
	return i;
}
#endif

#define cls clrscr
void clrscr()		{
	EffaceEcran();
	texteX=texteY=0;
}

#define TE_InsereCar(k)	{	memmove(chaine+curs+1,chaine+curs,longueur-curs); chaine[curs++]=k; chaine[++longueur]=0;	}
#define TE_BackSpace()		{	curs--; memmove(chaine+curs,chaine+curs+1,longueur-curs); chaine[--longueur]=0;	}
#define TE_Delete()		{	memmove(chaine+curs,chaine+curs+1,longueur-curs); chaine[--longueur]=0;			}


char *gets(char *chaine)		{
	int texteXsauv=texteX, texteYsauv=texteY, DoubleBufferSauv=DoubleBuffer;
	unsigned char *tampon=malloc(LARG_BUF*HAUT_BUF*3), *acoller;
	int longueur=0,k, curs=0,i;
	HANDLE h;

	if (!tampon)		{
		printf("Erreur: Mmoire\n");
		return chaine;
	}

	memcpy(tampon,Bits,LARG_BUF*HAUT_BUF*3);
	DoubleBuffer=TRUE;

	chaine[0]=0;
	while(1)		{
		memcpy(Bits,tampon,LARG_BUF*HAUT_BUF*3);
		texteX=texteXsauv,texteY=texteYsauv;
		gblIndex=curs;							//Pose une question globale
		printf(chaine);							//printf va afficher et rpondre par la mme occasion
		MoveTo(gblX/LARG_CAR,gblY/HAUT_CAR);	//Et la rponse est l.
		DoubleBuffer=FALSE;
		while(1)		{
			k=getkey();
			if (k)
				break;
			if (toucheAppuyee(T_HAUT) && curs>0)		{
				curs--;
				if (chaine[curs]=='\n' && curs>0)
					curs--;
				while (chaine[curs]!='\n' && curs>0)
					curs--;
				if (curs>0)
					curs++;
				break;
			}
			if (toucheAppuyee(T_BAS) && curs<longueur)		{
				curs++;
				while (chaine[curs]!='\n' && curs<longueur)
					curs++;
				break;
			}
			if (toucheAppuyee(T_GAUCHE) && curs>0)		{
				curs--;
				break;
			}
			if (toucheAppuyee(T_DROITE) && curs<longueur)		{
				curs++;
				break;
			}
			if (toucheAppuyee(T_DELETE) && curs<longueur)		{
				TE_Delete();
				break;
			}
			if (toucheAppuyee(T_ESCAPE))		{
				chaine[0]=0;
				getch();									//Vide le tampon
				k='\r';
				break;
			}
			if (toucheAppuyee('V') && testTouche(T_CTRL))		{
				OpenClipboard(hConsole);
				h=GetClipboardData(CF_TEXT);
				acoller=GlobalLock(h);
				i=strlen(acoller);
//				printf("%i %i %i",curs+i,curs,longueur-curs);
//				getch();
				memmove(chaine+curs+i,chaine+curs,longueur-curs);
				memcpy(chaine+curs,acoller,i);
				curs+=i;
//				chaine[curs]=k;
				longueur+=i;
				chaine[longueur]=0;
//				TE_ColleTexte(acoller);
				GlobalUnlock(h);
				CloseClipboard();
			}
		}
		DoubleBuffer=TRUE;
		if (k=='\r')				//'\n' si entre avec ctrl enfonc...
			break;
		if (k==8 && curs>0)		{	//Retour arrire
			TE_BackSpace();
		}
		if ((k>=32 && k<=255) || k=='\n')		{			//Un caractre
			TE_InsereCar(k);
		}
	}

	DoubleBuffer=DoubleBufferSauv;
	return chaine;
}

#define TitreFenetre(titre)		SetWindowText(hConsole,titre)
