/*
A IMPLMENTER

  -Systme graphique genre GBA.
  -Sprites en addition, soustraction, etc.
  -printf avec wordwrap
  -scanf complet
  -diteur de textes
  -doc
*/

#define ASSERT(condition)	if (!(condition))	  MessageBox(GetFocus(),"Erreur: "#condition,"Deception",0);
unsigned char *Bits=NULL;
#if (!defined(LARG) || !defined(HAUT))
	#define LARG 640
	#define HAUT 300
#endif
int CLIP_X0=0, CLIP_Y0=0, CLIP_X1=0, CLIP_Y1=0;
int LARG_BUF;
int HAUT_BUF;

HDC hdcImage;
typedef int ent;
int tx, ty;

unsigned char *bitsImage;
HBITMAP hbm;
HWND hConsole=0;
HDC hdcConsole;
HFONT fonteCourante=0;
LOGFONT logFCour;
int offsetX=0, offsetY=0;


BOOL AfficheEcran()		{
	return BitBlt(hdcConsole,offsetX,offsetY,LARG,HAUT,hdcImage,0,0,SRCCOPY);
}

BOOL LitEcran()		{
	return BitBlt(hdcImage,0,0,LARG,HAUT,hdcConsole,offsetX,offsetY,SRCCOPY);
}

void AffErreur()		{
	char *lpMsgBuf;
	char str[100];
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);
	sprintf(str,"Erreur n%i",GetLastError());
	MessageBox(NULL,lpMsgBuf,str,MB_ICONERROR);
}

#define EffaceEcran()	memset(Bits,0,LARG_BUF*(HAUT_BUF+1)*3)

#include <WinGraph\couleurs.h>
#include <WinGraph\cadres.h>
#include <WinGraph\clavier.h>
#include <WinGraph\geometrie.h>
#include <WinGraph\sprites.h>
#include <WinGraph\objets.h>
#include <WinGraph\timer.h>
#include <WinGraph\texte.h>
#include <WinGraph\console.h>
#include <WinGraph\souris.h>
#include <WinGraph\avance.h>

HRGN hrgn=0;

void ZoneEcran(int x0,int y0,int x1,int y1)		{
	RECT rect;
	CLIP_X0=x0, CLIP_Y0=y0, CLIP_X1=x1, CLIP_Y1=y1;
	rect.left=x0;
	rect.top=y0;
	rect.right=x1;
	rect.bottom=y1;
	if (hrgn)
		DeleteObject(hrgn);
	hrgn=CreateRectRgnIndirect(&rect);
	SelectClipRgn(hdcImage,hrgn);
}

BITMAPINFOHEADER BIH;

void CreeDIB(HDC hdc, int cx, int cy, int ibitcount, HBITMAP *hbm, void **bits) 
{
   // Create a BITMAPINFOHEADER structure to describe the DIB.
   int iSize = sizeof(BITMAPINFOHEADER);

   ASSERT((ibitcount == 8) || (ibitcount == 16) || (ibitcount == 24)) ;
   ASSERT(cx > 0);
   ASSERT(cy > 0);
   memset(&BIH, 0, iSize);

   // Fill in the header info. 
   BIH.biSize = iSize;
   BIH.biWidth = cx;
   BIH.biHeight = cy+1;
   BIH.biPlanes = 1;
   BIH.biBitCount = ibitcount;
   BIH.biCompression = BI_RGB;

   // Create a new device context.

   // Create the DIB section.
   *hbm = CreateDIBSection(hdc,
               (BITMAPINFO*) &BIH,
                             DIB_PAL_COLORS,
                             (void**)bits,
                             NULL,
                             0);

    ASSERT(*hbm);
    ASSERT(*bits);

    // Select the new bitmap into the buffer DC.
    if (*hbm)
    {
        SelectObject(hdc,*hbm);
    }
}


#ifndef EtatCurseur
	void EtatCurseur(int etat)		{
		CONSOLE_CURSOR_INFO cci;
		cci.bVisible=etat;
		cci.dwSize=1;
		SetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE),&cci);
	}
#endif

void RedimensionneConsole(int x, int y)		{
	RECT rect;
	GetWindowRect(hConsole,&rect);
	SetWindowPos(hConsole,HWND_TOPMOST,0,0,rect.right-rect.left+x,rect.bottom-rect.top+y,SWP_NOMOVE | SWP_NOZORDER);
}

void InitFonte()		{
	logFCour.lfOrientation=0;
	logFCour.lfWeight=FW_NORMAL;
	logFCour.lfItalic=0;
	logFCour.lfUnderline=0;
	logFCour.lfStrikeOut=0;
}

void InitUltra()		{
#ifndef MODE_WIN
	//Pour rcuprer la fentre en cours...
	hConsole=GetForegroundWindow();
#else
	hConsole=gblHWnd;
#endif
	//Pour pouvoir y crire...
	hdcConsole=GetDC(hConsole);
	//Cre un contexte de priphrique compatible avec l'cran en cours...
	hdcImage=CreateCompatibleDC(hdcConsole);
	//Attention: Cette tape ne doit surtout pas tre grille autrement votre affichage sera altr!
	if (LARG%4==0)
		LARG_BUF=LARG;
	else
		LARG_BUF=LARG+(4-LARG%4);
	HAUT_BUF=HAUT;
	//Cre une bitmap utilisable par mon systme graphique (graphlib)
	CreeDIB(hdcImage,LARG_BUF,HAUT_BUF,24,&hbm,(void**)&bitsImage);
	Bits=bitsImage;
	//Ouvre une "fentre" graphique (pas Window!) pour y dessiner
	ZoneEcran(0,0,LARG,HAUT);
	InitFonte();
	CouleurTexte(RGB(192,192,192));
	EtatCurseur(0);
}

void InitUltraEx()		{
	//Pour rcuprer la fentre en cours...
	hConsole=GetForegroundWindow();
	hdcConsole=GetWindowDC(hConsole);
	
	//Cre un contexte de priphrique compatible avec l'cran en cours...
	hdcImage=CreateCompatibleDC(hdcConsole);
	//Attention: Cette tape ne doit surtout pas tre grille autrement votre affichage sera altr!
	if (LARG%4==0)
		LARG_BUF=LARG;
	else
		LARG_BUF=LARG+(4-LARG%4);
	HAUT_BUF=HAUT;
	//Cre une bitmap utilisable par mon systme graphique (graphlib)
	CreeDIB(hdcImage,LARG_BUF,HAUT_BUF,24,&hbm,(void**)&bitsImage);
	Bits=bitsImage;
	//Ouvre une "fentre" graphique (pas Window!) pour y dessiner
	ZoneEcran(0,0,LARG,HAUT);
	offsetX=0;
	offsetY=0;
	InitFonte();
	CouleurTexte(RGB(192,192,192));
	EtatCurseur(0);
}

